diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
index b971b8d49..9cea92379 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSeat.java
@@ -3,12 +3,15 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntitySeat;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicSeat extends BlockLogic
 {
@@ -54,6 +57,11 @@ public class BlockLogicSeat extends BlockLogic
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, TileEntity tileEntity) {
         if (dropCause != EnumDropCause.IMPROPER_TOOL)
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
index 00009d94f..aa9431773 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSign.java
@@ -4,6 +4,8 @@ import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
@@ -13,6 +15,7 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicSign extends BlockLogic implements IPaintable
 {
@@ -75,6 +78,11 @@ public class BlockLogicSign extends BlockLogic implements IPaintable
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
index 6cc101808..2efdb8f6e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSlab.java
@@ -3,6 +3,9 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
@@ -25,6 +28,11 @@ public class BlockLogicSlab extends BlockLogic
     public Block<?> modelBlock;
     public int modelBlockMetadata;
 
+    public static final int MASK_STATE = 0b11;
+    public static final int STATE_LOWER = 0;
+    public static final int STATE_DOUBLE = 1;
+    public static final int STATE_UPPER = 2;
+
     public BlockLogicSlab(Block<?> block, Block<?> modelBlock)
     {
         this(block, modelBlock, 0);
@@ -54,13 +62,13 @@ public class BlockLogicSlab extends BlockLogic
     @Override
     public AABB getBlockBoundsFromState(WorldSource world, int x, int y, int z)
     {
-        int l = world.getBlockMetadata(x, y, z) & 0x3;
+        int l = world.getBlockMetadata(x, y, z) & MASK_STATE;
         switch (l) {
-            case 0:
+            case STATE_LOWER:
                 return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 0.5F, 1.0F);
-            case 1:
+            case STATE_DOUBLE:
                 return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-            case 2:
+            case STATE_UPPER:
             default:
                 return AABB.fromPool(0.0F, 0.5F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
@@ -77,14 +85,31 @@ public class BlockLogicSlab extends BlockLogic
     public boolean renderAsNormalBlockOnCondition(WorldSource world, int x, int y, int z)
     {
         int meta = world.getBlockMetadata(x, y, z);
-        return (meta & 0x3) == 1;
+        return (meta & MASK_STATE) == STATE_DOUBLE;
     }
 
     @Override
     public boolean canPlaceOnSurfaceOnCondition(World world, int x, int y, int z)
     {
         int meta = world.getBlockMetadata(x, y, z);
-        return (meta & 0x3) != 0;
+        return (meta & MASK_STATE) != STATE_LOWER;
+    }
+
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        int state = world.getBlockMetadata(x, y, z) & MASK_STATE;
+        switch (side) {
+            case TOP: return state == STATE_UPPER || state == STATE_DOUBLE ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+            case BOTTOM: return state == STATE_LOWER || state == STATE_DOUBLE ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+            default:
+                switch (state) {
+                    case STATE_LOWER: return PartialSupport.INSTANCE.down();
+                    case STATE_UPPER: return PartialSupport.INSTANCE.up();
+                    case STATE_DOUBLE:
+                    default:
+                        return FullSupport.INSTANCE;
+                }
+        }
     }
 
     @Override
@@ -98,7 +123,7 @@ public class BlockLogicSlab extends BlockLogic
             {
                 stack.setMetadata(meta & 0xF0);
                 stack.itemID = this.id();
-                if ((meta & 0b11) == 1 && dropCause != EnumDropCause.PICK_BLOCK) stack.stackSize = 2;
+                if ((meta & MASK_STATE) == STATE_DOUBLE && dropCause != EnumDropCause.PICK_BLOCK) stack.stackSize = 2;
                 else stack.stackSize = 1;
             }
         }
@@ -142,9 +167,9 @@ public class BlockLogicSlab extends BlockLogic
         modelBlock.onEntityWalking(world, x, y, z, entity);
     }
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
-        modelBlock.updateTick(world, x, y, z, rand);
+        modelBlock.updateTick(world, x, y, z, rand, false);
     }
     @Override
     public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
index 16ec10324..ec56a7e0f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSnow.java
@@ -20,7 +20,7 @@ public class BlockLogicSnow extends BlockLogic
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(world.getSavedLightValue(LightLayer.Block, x, y, z) > 11)
         {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
index 1c815a00b..bac712460 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSpikes.java
@@ -1,6 +1,9 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.Mob;
@@ -117,4 +120,9 @@ public class BlockLogicSpikes extends BlockLogic
     public boolean isCubeShaped() {
         return false;
     }
+
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return side == Side.BOTTOM ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+    }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
index 76b42e69b..83d9ab602 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStairs.java
@@ -6,6 +6,9 @@ import java.util.Random;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.phys.Vec3;
@@ -82,6 +85,89 @@ public class BlockLogicStairs extends BlockLogic
 //        vol.bake();
 //        selectionVolumes.put(0b1011, vol);
 //    }
+    public static final int MASK_ROTATION_HORIZONTAL = 0b0000_0011;
+    public static final int MASK_ROTATION_VERTICAL = 0b0000_1000;
+
+    public static final int H_ROTATION_WEST = 0;
+    public static final int H_ROTATION_EAST = 1;
+    public static final int H_ROTATION_NORTH = 2;
+    public static final int H_ROTATION_SOUTH = 3;
+
+    public static final ISupport[] lowerStairsSupportMapping = {
+        // Side Bottom
+        FullSupport.INSTANCE,       // West
+        FullSupport.INSTANCE,       // East
+        FullSupport.INSTANCE,       // North
+        FullSupport.INSTANCE,       // South
+
+        // Side Top
+        PartialSupport.INSTANCE.right(),    // West
+        PartialSupport.INSTANCE.left(),    // East
+        PartialSupport.INSTANCE.down(),    // North
+        PartialSupport.INSTANCE.up(),    // South
+
+        // Side North
+        PartialSupport.INSTANCE.down().right(),    // West
+        PartialSupport.INSTANCE.down().left(),    // East
+        PartialSupport.INSTANCE.down(),    // North
+        FullSupport.INSTANCE,       // South
+
+        // Side South
+        PartialSupport.INSTANCE.down().right(),    // West
+        PartialSupport.INSTANCE.down().left(),    // East
+        FullSupport.INSTANCE,       // North
+        PartialSupport.INSTANCE.down(),    // South
+
+        // Side West
+        PartialSupport.INSTANCE.down(),    // West
+        FullSupport.INSTANCE,       // East
+        PartialSupport.INSTANCE.down().left(),    // North
+        PartialSupport.INSTANCE.down().right(),    // South
+
+        // Side East
+        FullSupport.INSTANCE,       // West
+        PartialSupport.INSTANCE.down(),    // East
+        PartialSupport.INSTANCE.down().left(),    // North
+        PartialSupport.INSTANCE.down().right(),    // South
+    };
+
+    public static final ISupport[] upperStairsSupportMapping = {
+        // Side Bottom
+        PartialSupport.INSTANCE.right(),    // West
+        PartialSupport.INSTANCE.left(),    // East
+        PartialSupport.INSTANCE.down(),    // North
+        PartialSupport.INSTANCE.up(),    // South
+
+        // Side Top
+        FullSupport.INSTANCE,       // West
+        FullSupport.INSTANCE,       // East
+        FullSupport.INSTANCE,       // North
+        FullSupport.INSTANCE,       // South
+
+        // Side North
+        PartialSupport.INSTANCE.up().right(),    // West
+        PartialSupport.INSTANCE.up().left(),    // East
+        PartialSupport.INSTANCE.up(),    // North
+        FullSupport.INSTANCE,       // South
+
+        // Side South
+        PartialSupport.INSTANCE.up().right(),    // West
+        PartialSupport.INSTANCE.up().left(),    // East
+        FullSupport.INSTANCE,       // North
+        PartialSupport.INSTANCE.up(),    // South
+
+        // Side West
+        PartialSupport.INSTANCE.up(),    // West
+        FullSupport.INSTANCE,       // East
+        PartialSupport.INSTANCE.up().left(),    // North
+        PartialSupport.INSTANCE.up().right(),    // South
+
+        // Side East
+        FullSupport.INSTANCE,       // West
+        PartialSupport.INSTANCE.up(),    // East
+        PartialSupport.INSTANCE.up().left(),    // North
+        PartialSupport.INSTANCE.up().right(),    // South
+    };
 
     public Block<?> modelBlock;
 
@@ -117,31 +203,43 @@ public class BlockLogicStairs extends BlockLogic
 
     @Override
     public boolean canPlaceOnSurfaceOnCondition(World world, int x, int y, int z) {
-    	return (world.getBlockMetadata(x, y, z) & 8) > 0;
+    	return (world.getBlockMetadata(x, y, z) & MASK_ROTATION_VERTICAL) != 0;
+    }
+
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        int meta = world.getBlockMetadata(x, y, z);
+        int hRot = meta & MASK_ROTATION_HORIZONTAL;
+        if ((meta & MASK_ROTATION_VERTICAL) != 0) {
+            return upperStairsSupportMapping[side.getId() * 4 + hRot];
+        } else {
+            return lowerStairsSupportMapping[side.getId() * 4 + hRot];
+        }
     }
 
     @Override
     public void getCollidingBoundingBoxes(World world, int x, int y, int z, AABB aabb, ArrayList<AABB> aabbList)
     {
         int meta = world.getBlockMetadata(x, y, z);
-        int hRotation = meta & 0b0011;
-        int vRotation = meta & 0b1000;
+        int hRotation = meta & MASK_ROTATION_HORIZONTAL;
+        int vRotation = meta & MASK_ROTATION_VERTICAL;
 
-        float stepYOffset = vRotation > 0 ? 0.5f : 0.0f;
+        float stepYOffset = vRotation != 0 ? 0.5f : 0.0f;
 
         switch (hRotation) {
-            case 0:
+            case H_ROTATION_WEST:
                 addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F + stepYOffset, 0.0F, 0.5F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
                 addIntersectingBoundingBox(aabb, AABB.fromPool(0.5F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
                 break;
-            case 1:
+            case H_ROTATION_EAST:
                 addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, 0.5F, 1.0F, 1.0F).move(x, y, z), aabbList);
                 addIntersectingBoundingBox(aabb, AABB.fromPool(0.5F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
                 break;
-            case 2:
+            case H_ROTATION_NORTH:
                 addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F + stepYOffset, 0.0F, 1.0F, 0.5F + stepYOffset, 0.5F).move(x, y, z), aabbList);
                 addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.5F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
                 break;
+            case H_ROTATION_SOUTH:
             default:
                 addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.5F).move(x, y, z), aabbList);
                 addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F + stepYOffset, 0.5F, 1.0F, 0.5F + stepYOffset, 1.0F).move(x, y, z), aabbList);
@@ -242,9 +340,9 @@ public class BlockLogicStairs extends BlockLogic
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
-        modelBlock.updateTick(world, x, y, z, rand);
+        modelBlock.updateTick(world, x, y, z, rand, false);
     }
 
     @Override
@@ -266,14 +364,14 @@ public class BlockLogicStairs extends BlockLogic
         int meta = world.getBlockMetadata(x, y, z) & 0xF0;
 
         Direction hRotation = mob.getHorizontalPlacementDirection(side).getOpposite();
-        if(hRotation == Direction.NORTH) meta |= 0b0010;
-        if(hRotation == Direction.EAST) meta |= 0b0001;
-        if(hRotation == Direction.SOUTH) meta |= 0b0011;
-        if(hRotation == Direction.WEST) meta |= 0b0000;
+        if(hRotation == Direction.NORTH) meta |= H_ROTATION_NORTH;
+        if(hRotation == Direction.EAST) meta |= H_ROTATION_EAST;
+        if(hRotation == Direction.SOUTH) meta |= H_ROTATION_SOUTH;
+        if(hRotation == Direction.WEST) meta |= H_ROTATION_WEST;
 
         Direction vRotation = mob.getVerticalPlacementDirection(side, yPlaced);
-        if (vRotation == Direction.DOWN) meta |= 0b0000;
-        if (vRotation == Direction.UP) meta |= 0b1000;
+//        if (vRotation == Direction.DOWN) meta |= 0b0000;
+        if (vRotation == Direction.UP) meta |= MASK_ROTATION_VERTICAL;
 
         world.setBlockMetadataWithNotify(x, y, z, meta);
     }
@@ -285,15 +383,15 @@ public class BlockLogicStairs extends BlockLogic
         side = side.getOpposite();
         Side hSide = !side.isHorizontal() ? Side.NORTH : side;
         Direction hRotation = hSide.getOpposite().getDirection();
-        if(hRotation == Direction.NORTH) meta |= 0b0010;
-        if(hRotation == Direction.EAST) meta |= 0b0001;
-        if(hRotation == Direction.SOUTH) meta |= 0b0011;
-        if(hRotation == Direction.WEST) meta |= 0b0000;
+        if(hRotation == Direction.NORTH) meta |= H_ROTATION_NORTH;
+        if(hRotation == Direction.EAST) meta |= H_ROTATION_EAST;
+        if(hRotation == Direction.SOUTH) meta |= H_ROTATION_SOUTH;
+        if(hRotation == Direction.WEST) meta |= H_ROTATION_WEST;
 
         Side vSide = !side.isVertical() ? Side.BOTTOM : side;
         Direction vRotation = vSide.getDirection();
-        if (vRotation == Direction.DOWN) meta |= 0b0000;
-        if (vRotation == Direction.UP) meta |= 0b1000;
+//        if (vRotation == Direction.DOWN) meta |= 0b0000;
+        if (vRotation == Direction.UP) meta |= MASK_ROTATION_VERTICAL;
 
         world.setBlockMetadataWithNotify(x, y, z, meta);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStalk.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStalk.java
index 8f369d1be..a669f0831 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStalk.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStalk.java
@@ -1,9 +1,14 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
+import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockLogicStalk extends BlockLogic {
     public BlockLogicStalk(Block<?> block) {
@@ -33,6 +38,11 @@ public class BlockLogicStalk extends BlockLogic {
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z) {
         return null;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
index d5b1c3008..7dd5c0d94 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicStatue.java
@@ -3,6 +3,9 @@ package net.minecraft.core.block;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.entity.TileEntityStatue;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.support.FullSupport;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.enums.HumanArmorShape;
@@ -157,6 +160,11 @@ public class BlockLogicStatue extends BlockLogic {
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     public @Nullable TileEntityStatue getTileEntity(final @NotNull World world, final int x, final int y, final int z) {
         final @Nullable Block<?> block = world.getBlock(x, this.isBottom ? y : y - 1, z);
         if (block == null || !(block.getLogic() instanceof BlockLogicStatue)) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
index c06688617..3c585db62 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicSugarcane.java
@@ -1,6 +1,8 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.support.ISupport;
+import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.util.helper.Side;
@@ -12,6 +14,7 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
@@ -28,7 +31,7 @@ public class BlockLogicSugarcane extends BlockLogic implements IBonemealable
     }
 
     @Override
-	public void updateTick(World world, int x, int y, int z, Random rand)
+	public void updateTick(World world, int x, int y, int z, Random rand, boolean isRandomTick)
     {
         if(world.isAirBlock(x, y + 1, z))
         {
@@ -133,6 +136,11 @@ public class BlockLogicSugarcane extends BlockLogic implements IBonemealable
         return false;
     }
 
+    @Override
+    public @NotNull ISupport getSupport(@NotNull World world, int x, int y, int z, @NotNull Side side) {
+        return PartialSupport.INSTANCE;
+    }
+
     @Override
     public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(!world.isClientSide)
